# the implementation of ***Collaborate to Defend Against Adversarial Attacks***

### Acknowledgments
Part of the codes refer to the work [1], [2].

### file description
1. main.py, the main function file, including all hyper-parameter setting;
2. distillation.py, the auxiliary functions are in this file;
3. utils/util_data.py, the function for handling the data processing;
4. utils/util_func.py, the necessary function are in this file.
5. eval/eval.py, the necessary function for evaluating the learned model;
6. models/learn.py, the function for training the model;
7. models/model.py, the model structure is defined in this file.


### training
python main.py \
    --batch_size 128 \
    --attack_type "white_box" \
    --gpu 1 \
    --attack_eps  0.01 \
    --depth 20 \
    --target_dir "outputs" \
    --total_epoches 200 \
    --num_experts 3 \
    --plus_at_type "together" \
    --ppd_type "simple" \
    --subset_num  1000 \
    --lr_expert 0.1 \
    --adaptivetrainlambda 1.0 \
    --wbox_type_pgd \
    --optim_type "sgd" \
    --test_interval_epoches 1 \


### evaluating
python main.py \
    --batch_size 128 \
    --attack_type "white_box" \
    --gpu 1 \
    --attack_eps  0.01 \
    --depth 20 \
    --target_dir "outputs" \
    --total_epoches 200 \
    --num_experts 3 \
    --plus_at_type "together" \
    --ppd_type "simple" \
    --subset_num  1000 \
    --lr_expert 0.1 \
    --adaptivetrainlambda 1.0 \
    --wbox_type_pgd \
    --optim_type "sgd" \
    --test_interval_epoches 1 \
    --eval_mode


[1] Huanrui Yang, Jingyang Zhang, Hongliang Dong, Nathan Inkawhich, Andrew Gardner, AndrewTouchet,  Wesley Wilkes,  Heath Berry,  and Hai Li.   Dverge:  Diversifying vulnerabilities forenhanced robust generation of ensembles. InNeurIPS, 2020a.
[2] Tianyu Pang, Huishuai Zhang, Di He, Yinpeng Dong, Hang Su, Wei Chen, Jun Zhu, and Tie-Yan Liu.Adversarial training with rectified rejection.arXiv preprint arXiv:2105.14785, 2021.